/***********************************************(abc889_18426.c)***
 *      NEC/SONYԊOȒM
 ****************************************************************/

#include "mcc_generated_files/mcc.h"
#include "string.h"
#include "i2cLCD_ST7032i.h"

#define MAXDATA 90                                  // ԊOf[^[z
#define MAXADDR 10                                  // SONYAhXz
/*
#define BFSIZE  20                                  // eusart.hŒ`
*/
// ----- NEC pulse time parameter ----
#define	MARK()      __delay_us(562)
#define SPACE_1()   __delay_us(1686)
#define SPACE_0()   __delay_us(562)
#define LEADER_1()  __delay_us(8992)
#define LEADER_0()  __delay_us(4496)
#define GYAP_0()    __delay_ms(43)
// ---- SONY puls time parameter -----
#define S_LEADER()  __delay_us(2400)
#define S_SPACE()   __delay_us(600)
#define S_MARK_0()  __delay_us(600)
#define S_MARK_1()  __delay_us(1200)
#define S_GYAP_20() __delay_ms(19)
#define S_GYAP_15() __delay_ms(25)
#define S_GYAP_12() __delay_ms(29)
// ----- DSM controle ----
#define DSM_1()		(MD1CON0bits.MD1BIT = 1)
#define DSM_0()		(MD1CON0bits.MD1BIT = 0)
#define SMT_START()	(SMT1CON1bits.SMT1GO = 1)
#define SMT_STOP()	(SMT1CON1bits.SMT1GO = 0)

// ---- IOdata Customer Code ----
#define IO_CUSTOM   0xE880

/* -----  Variables  ----- */
uint16_t PW[MAXDATA];                               // Markz
int16_t  PR[MAXDATA];                               // Spacez
uint8_t  p_PW;                                      // Markz|C^
uint8_t  p_PR;                                      // Spacez|C^

char     sBf[BFSIZE];                               // ƃGA
char     rBuf[BFSIZE];                              // VAMobt@
uint8_t  sFlg;                                      // VAMtO
//uint8_t  sIdx;                                      // VAM|C^
uint8_t  Sony;                                      // SonytH[}bgH
uint16_t Sa[MAXADDR];                                // SONYAhXz

uint16_t IO2[] = {0x1084,0x2084,0x3084};            // IOdataԊOR[h

/*----- Send NEC Code  -----*/
void Ir_Leader(){
    DSM_1();                                        // send Leader
    LEADER_1();
    DSM_0();
    LEADER_0();
}

void Ir_Stop(){
    DSM_1();
    MARK();                                         // send stop
    DSM_0();
}

void Ir_Send(uint8_t *dt, uint8_t x){               // send Byte
    uint8_t sft;
    for (int j = 0; j < x;j++){
        sft = 0x01;
        for(int i = 0; i < 8;i++){
            DSM_1();
            MARK();
            DSM_0();
            if(dt[j] & sft)  SPACE_1();
            else             SPACE_0();
            sft <<= 1;
        }
    }
}

void Ir_Send2(uint16_t wd){                         // send Word
    uint16_t wsft = 0x0001;
    for(int i = 0; i < 16;i++){
        DSM_1();
        MARK();
        DSM_0();
        if(wd & wsft)   SPACE_1();
        else            SPACE_0();
        wsft <<= 1;
    }
}

void send_NEC(uint16_t cst, uint16_t d){
    uint16_t dat;
    IO_RC2_SetLow();
    SMT_STOP();                                     // ԊO蒆f
    dat = (d & 0x00FF) | ((~d << 8) & 0xFF00);      // Calc data code
    Ir_Leader();                                    // Leader Start
    Ir_Send2(cst);                                  // Send Custmer
    Ir_Send2(dat);                                  // Send Data
    Ir_Stop();         	                            // stop
    LCD_clr();
    sprintf(sBf,">NEC %04X-%04X",cst,dat);
    LCD_str(sBf);
    printf("\n\r>NEC %04X-%04X",cst,dat);
    SMT_START();                                    // ԊOĊJ
}

/*----- Send IOdata code  ------*/

void send_IOdata(uint8_t c){                        // from IOarray(word)
    uint16_t w = IO2[c];
    uint16_t wLo;
    uint16_t wHi;
    IO_RC2_SetLow();
    SMT_STOP();                                     // ԊO蒆f
    wLo = (w & 0x00FF) | ((~w << 8) & 0xFF00);      // Calc Low word
    wHi = ((w >> 8) & 0x00FF) | (~w & 0xFF00);      // Calc High word
    Ir_Leader();                                    // Leader Start
    Ir_Send2(IO_CUSTOM);                            // Send Custom  
    Ir_Send2(wLo);                                  // Send Data1
    Ir_Stop();         	                            // stop
    GYAP_0();                                       // Gyap time
    Ir_Leader();                                    // Leader Start 
    Ir_Send2(IO_CUSTOM);                            // Send Custom  
    Ir_Send2(wHi);                                  // Send Data2
    Ir_Stop();                                      // stop
    LCD_clr();
    sprintf(sBf,">IOdata %08X",w);
    LCD_str(sBf);
    printf("\n\r>IOdata %08X",w);
    SMT_START();                                    // ԊOĊJ
}

/*----- Send SONY Code ----*/
void send_SONY(uint16_t wd, uint16_t ad){
    uint8_t  btc;                                   // bit counter
    uint32_t icd;                                   // IRcode data
    uint8_t  adx;                                   // address number
    uint32_t sft;                                   // shift data
 
    LCD_clr();
    sprintf(sBf,">Sony:%04X-%04X",wd,ad);
    LCD_str(sBf);
    printf("\r\n%s\n\r",sBf);
    icd = (uint32_t)(wd & 0x007F);
    if(wd & 0x0080){                                // 15bit mode?
        btc = 15;
        icd += (uint32_t)((wd >> 1) & 0x7F80); 
    }else{
        if(wd & 0x8000){                            // 20bit mode?
            btc = 20;
            adx = (wd >> 8) & 0x003F;
            if(adx >= MAXADDR){
                btc = 0;
            }else{
                if(wd & 0x4000){                    // write?
                    icd += (uint32_t)ad << 7;
                    Sa[adx] = ad;
                }else{                              // read
                    icd += (uint32_t)Sa[adx] << 7;
                }
            }
        }else{                                      // 12bit mode
            btc = 12;
            icd += (uint32_t)((wd >> 1) & 0x0F80);
        }
    }
    if(btc){
        IO_RC2_SetHigh();
        SMT_STOP();                                 // 蒆f
        sft = 0x00000001;
        DSM_1();                                    // send Leader
        S_LEADER();
        for(int i = 0; i < btc; i++){
            DSM_0();                                // send Space
            S_SPACE();
            DSM_1();                                // send Mark
            if(icd & sft)  S_MARK_1();
            else           S_MARK_0();
            sft <<= 1;
        }
        DSM_0();                                    // send Stop
        if(btc==20){
            S_GYAP_20();
        }else if(btc==15){
            S_GYAP_15();
        }else{
            S_GYAP_12();
        }
        sprintf(sBf,"- IR %05X",(icd & 0x0FFFFF));       
        LCD_cursor(0,1);
        LCD_str(sBf);
        printf("\r%s",sBf);
        SMT_START();                                // ĊJ

    }
}

void prt_Hex(uint8_t w, uint8_t n){                // 16i\
    if(n){
        sprintf(sBf,"%02X ",w);
        printf("  >> %02XH\n\r",w);
    }else{
        sprintf(sBf,"%02X",w);
        printf("  >> %02XH",w);  
    }
    LCD_str(sBf);                                   // LCD\
 }

/*-------------------------------------------
 *            Main application
 *-------------------------------------------*/
void main(void)
{
    uint8_t  ird;                                   // ԊOf[^
    uint8_t  sbt;                                   // rbgZbgpVtgoCg
    uint8_t  bct;                                   // Lrbgf[^JE^
    uint8_t  sgf;                                   // f[^LtO
    uint16_t sDat;
    uint16_t sAdr;
    char     *end;

    SYSTEM_Initialize();                            // foCX
    LCD_init();                                     // LCD

    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();

    LCD_str("== ready ==");
        // --- eXgpf[^Zbg
    Sa[0] = 0x04B9;                                 // SONYftHgAhX
    sDat  = 0xC000;
    sAdr  = 0x1C5A;

    while (1)                                       // ԊOMM@JԂ
    {
        p_PW = 0;                                   // f[^|C^
        p_PR = 0;
        SMT1PWAIF = 0;                              // tONA
        SMT1PRAIF = 0;
        SMT1IF = 0;
        SMT_START();                                // Jn
        printf("\r\n-ready\r\n");                  // bZ[WM

        // ====== ԊOM̎MEo[v =====
        while((p_PR < MAXDATA)){                    // obt@t܂ŌJ
            if(sFlg){                               // Mf[^΁H
                if(strchr(rBuf,'X') || strchr(rBuf,'x')){
                    sDat = (uint16_t)strtol(rBuf, &end, 16);
                    sAdr = (uint16_t)strtol(end,  NULL, 16);
                    send_SONY(sDat,sAdr);           // VAMf[^𑗐M
                    send_SONY(sDat,sAdr);           // VAMf[^𑗐M
                }else{
                    uint8_t n = atoi(rBuf);
                    if(n > 0 & n < 4)
                        send_IOdata(n-1);
                }
                sFlg = 0;                           // VAtONA
                printf("\n\r");
            }
            if(PORTCbits.RC4 == 0){                 // M{^ĂH
            // ----- ԊOR[hM ieXg͈ȉ̂ǂꂩLɂj----- 
                send_SONY(sDat,sAdr);               // Of[^𑗐M
            //    send_IOdata(0);                     // ԊOR[hM(IOdata)
            //    send_SONY(0x0200,0);                // ԊOR[hM(SONY12)
            //    send_SONY(0xB4D0,0);                // ԊOR[hM(SONY15)
            //    send_SONY(0xC000,0x1C5A);           // ԊOR[hM(SONY20)
            //    send_SONY(0x8000,0);                // ԊOR[hM(SONY20)
            }
/*          // ---- LCDʃVtg -----
            if(PORTAbits.RA0 == 0){                 // {^0Ă
                LCD_sift(RIGHT);                    // LCD\EVtg
                __delay_ms(100);                    // `^O΍
            }
            if(PORTAbits.RA1 == 0){                 // {^1Ă
                LCD_sift(LEFT);                     // LCD\Vtg
                __delay_ms(100);                    // `^O΍
            }
 */
            // ----- ԊOMM ----
            if(SMT1PWAIF){                          // markIȂ
                SMT1PWAIF = 0;                      // tONA
                PW[p_PW++]=SMT1CPW;                 // HighԂۑ
            }
            if(SMT1PRAIF){                          // spaceIȂ
                SMT1PRAIF = 0;                      // tONA
                if(SMT1CPR < 10000){                // 10msȂ
                    PR[p_PR++]=SMT1CPR;             //   ̂܂LowԂۑ
                }else{                              // 10msȏȂ
                    PR[p_PR++]=-(SMT1CPR / 1000);   //   msɕϊŕۑ
                }
            }
            if(SMT1IF){                             // M100ms
                SMT1IF = 0;                         // tONA
                PR[p_PR++]=0;                       // MLu0vۑ
                break;
            }
        }
        SMT_STOP();                                 // I

        // ===== Mʂ́EM =====
        ird = 0;
        sbt = 1;
        bct = 0;
        sgf = 0;
        LCD_clr();
        if(PW[0]<3000){
            Sony = 7;                               // -> SONY Mode
            IO_RC2_SetHigh();
            sprintf(sBf,"$SONY, %d",p_PW);
            LCD_str(sBf);
            puts(sBf);
        }else{
            Sony = 0;                               // -> NEC Mode
            IO_RC2_SetLow();
            sprintf(sBf,"$NEC, %d",p_PW);
            LCD_str(sBf);
            puts(sBf);
        }
        printf(" -  mark  space (us)\r\n");        // ^CgM
        LCD_cursor(0,1);
        for(char i = 0; i < p_PW; i++){             // ۑԂ𑗐M
            printf("%2d %5d",i,(uint16_t)PW[i]);    // mark
            if(PR[i]==0) {                          // MȂ
                printf("    ---");                  //  u---v𑗐M
                if(Sony){
                    if(PW[i] < 1600){                   // mark1600usȂ
                        bct++;
                        if(PW[i] > 900){                // mark900usȂ
                            ird |= sbt;                 // VtgoCg
                            printf("  1");
                        }else{
                            printf("  0");
                        }
                        prt_Hex(ird, 0);                // 16iŕ\
                    }
                }             
            }else if(PR[i] > 0){                    // 10msȂ
                printf("  %5d",PR[i]);              //   usPʂőM(sOj
                if (Sony){                          // *** SONY Code (Mark) ***
                    if(PW[i] < 1600){               // mark1500usȂ
                        sgf = 1;                    // Lf[^
                        if(PW[i] > 900){            // mark900usȂ
                            ird |= sbt;             // VtgoCg
                            printf("  1");
                        }else{
                            printf("  0");
                        }
                    }
                }else{                              // *** NEC Code (Space) ***
                    if(PW[i] < 1500){               // mark1500Ȃ
                        if(PR[i]<2000){             // space2000Ȃ
                            sgf = 1;                // Lf[^
                            if(PR[i]>900){          // space900ȏȂ
                                ird |= sbt;         // VtgoCg
                                printf("  1");
                            }else{
                                printf("  0");
                            }
                        }
                    }
                }
                if(sgf){                            // Lf[^Ȃ 
                    sbt <<= 1;                      // VtgoCgփVtg
                    bct++;                          // Lf[^1₷
                    if(Sony){                       // R[hSONYȂ
                        if(bct == Sony){
                            prt_Hex(ird, 0);        // 16iőM(\j
                            ird = 0;                // ԊOf[^NA 
                            sbt = 1;                // VtgoCg  
                            Sony = bct + 8;
                        }
                    }else{                          // R[hSONYȊOiNEC)
                        if((bct % 8) == 0){         // f[^8̔{Ȃ
                            prt_Hex(ird, 0);        // 16iőM(\j
                            ird = 0;                // ԊOf[^NA 
                            sbt = 1;                // VtgoCg  
                        }
                    }
                    sgf = 0;
                }
            }else{                                  // 10msȂ
                printf("%7d (ms)",-PR[i]);          //   msPʂőM
                 if(Sony){
                    if(PW[i] < 1600){               // mark1500usȂ
                        bct++;
                        if(PW[i] > 900){            // mark900usȂ
                            ird |= sbt;             // VtgoCg
                            printf("  1");
                        }else{
                            printf("  0");
                        }
                        prt_Hex(ird, 1);            // 16iőM(\)
                        ird = 0;                    // ԊOf[^NA 
                        sbt = 1;                    // VtgoCg 
                        Sony = bct + 7;
                    }
                }
            }
            printf("\r\n");
        }
        if(p_PW >= MAXDATA){                        // obt@tȂ
            printf("-- Buffer Full --\r\n");        //  Buffer Full M
        }
    }
}

/*****   End of File   *****/
